/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 19:15:42 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.shopping.model;

/**
 * Model definition for Product.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Product extends com.google.api.client.json.GenericJson {

  /**
   * List of categories for product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ShoppingModelCategoryJsonV1> categories;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ShoppingModelDebugJsonV1 debug;

  /**
   * Id of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The kind of item, always shopping#product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ShoppingModelProductJsonV1 product;

  /**
   * Recommendations for product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ShoppingModelRecommendationsJsonV1> recommendations;

  /**
   * Unique identifier for this request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String requestId;

  /**
   * Self link of product when generated for a lookup request. Self link of product when generated
   * for a search request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * List of categories for product.
   * @return value or {@code null} for none
   */
  public java.util.List<ShoppingModelCategoryJsonV1> getCategories() {
    return categories;
  }

  /**
   * List of categories for product.
   * @param categories categories or {@code null} for none
   */
  public Product setCategories(java.util.List<ShoppingModelCategoryJsonV1> categories) {
    this.categories = categories;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 getDebug() {
    return debug;
  }

  /**
   * Google internal.
   * @param debug debug or {@code null} for none
   */
  public Product setDebug(ShoppingModelDebugJsonV1 debug) {
    this.debug = debug;
    return this;
  }

  /**
   * Id of product.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Id of product.
   * @param id id or {@code null} for none
   */
  public Product setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind of item, always shopping#product.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of item, always shopping#product.
   * @param kind kind or {@code null} for none
   */
  public Product setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Product.
   * @return value or {@code null} for none
   */
  public ShoppingModelProductJsonV1 getProduct() {
    return product;
  }

  /**
   * Product.
   * @param product product or {@code null} for none
   */
  public Product setProduct(ShoppingModelProductJsonV1 product) {
    this.product = product;
    return this;
  }

  /**
   * Recommendations for product.
   * @return value or {@code null} for none
   */
  public java.util.List<ShoppingModelRecommendationsJsonV1> getRecommendations() {
    return recommendations;
  }

  /**
   * Recommendations for product.
   * @param recommendations recommendations or {@code null} for none
   */
  public Product setRecommendations(java.util.List<ShoppingModelRecommendationsJsonV1> recommendations) {
    this.recommendations = recommendations;
    return this;
  }

  /**
   * Unique identifier for this request.
   * @return value or {@code null} for none
   */
  public java.lang.String getRequestId() {
    return requestId;
  }

  /**
   * Unique identifier for this request.
   * @param requestId requestId or {@code null} for none
   */
  public Product setRequestId(java.lang.String requestId) {
    this.requestId = requestId;
    return this;
  }

  /**
   * Self link of product when generated for a lookup request. Self link of product when generated
   * for a search request.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * Self link of product when generated for a lookup request. Self link of product when generated
   * for a search request.
   * @param selfLink selfLink or {@code null} for none
   */
  public Product setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  @Override
  public Product set(String fieldName, Object value) {
    return (Product) super.set(fieldName, value);
  }

  @Override
  public Product clone() {
    return (Product) super.clone();
  }

}
