/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 19:15:42 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.shopping.model;

/**
 * Model definition for ShoppingModelDebugJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelDebugJsonV1 extends com.google.api.client.json.GenericJson {

  /**
   * Google internal
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<BackendTimes> backendTimes;

  static {
    // hack to force ProGuard to consider BackendTimes used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(BackendTimes.class);
  }

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long elapsedMillis;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String facetsRequest;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String facetsResponse;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String rdcResponse;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String recommendedItemsRequest;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String recommendedItemsResponse;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String searchRequest;

  /**
   * Google internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String searchResponse;

  /**
   * Google internal
   * @return value or {@code null} for none
   */
  public java.util.List<BackendTimes> getBackendTimes() {
    return backendTimes;
  }

  /**
   * Google internal
   * @param backendTimes backendTimes or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setBackendTimes(java.util.List<BackendTimes> backendTimes) {
    this.backendTimes = backendTimes;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.Long getElapsedMillis() {
    return elapsedMillis;
  }

  /**
   * Google internal.
   * @param elapsedMillis elapsedMillis or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setElapsedMillis(java.lang.Long elapsedMillis) {
    this.elapsedMillis = elapsedMillis;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getFacetsRequest() {
    return facetsRequest;
  }

  /**
   * Google internal.
   * @param facetsRequest facetsRequest or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setFacetsRequest(java.lang.String facetsRequest) {
    this.facetsRequest = facetsRequest;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getFacetsResponse() {
    return facetsResponse;
  }

  /**
   * Google internal.
   * @param facetsResponse facetsResponse or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setFacetsResponse(java.lang.String facetsResponse) {
    this.facetsResponse = facetsResponse;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getRdcResponse() {
    return rdcResponse;
  }

  /**
   * Google internal.
   * @param rdcResponse rdcResponse or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setRdcResponse(java.lang.String rdcResponse) {
    this.rdcResponse = rdcResponse;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getRecommendedItemsRequest() {
    return recommendedItemsRequest;
  }

  /**
   * Google internal.
   * @param recommendedItemsRequest recommendedItemsRequest or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setRecommendedItemsRequest(java.lang.String recommendedItemsRequest) {
    this.recommendedItemsRequest = recommendedItemsRequest;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getRecommendedItemsResponse() {
    return recommendedItemsResponse;
  }

  /**
   * Google internal.
   * @param recommendedItemsResponse recommendedItemsResponse or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setRecommendedItemsResponse(java.lang.String recommendedItemsResponse) {
    this.recommendedItemsResponse = recommendedItemsResponse;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getSearchRequest() {
    return searchRequest;
  }

  /**
   * Google internal.
   * @param searchRequest searchRequest or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setSearchRequest(java.lang.String searchRequest) {
    this.searchRequest = searchRequest;
    return this;
  }

  /**
   * Google internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getSearchResponse() {
    return searchResponse;
  }

  /**
   * Google internal.
   * @param searchResponse searchResponse or {@code null} for none
   */
  public ShoppingModelDebugJsonV1 setSearchResponse(java.lang.String searchResponse) {
    this.searchResponse = searchResponse;
    return this;
  }

  @Override
  public ShoppingModelDebugJsonV1 set(String fieldName, Object value) {
    return (ShoppingModelDebugJsonV1) super.set(fieldName, value);
  }

  @Override
  public ShoppingModelDebugJsonV1 clone() {
    return (ShoppingModelDebugJsonV1) super.clone();
  }

  /**
   * Model definition for ShoppingModelDebugJsonV1BackendTimes.
   */
  public static final class BackendTimes extends com.google.api.client.json.GenericJson {

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long elapsedMillis;

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String hostName;

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Google internal
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long serverMillis;

    /**
     * Google internal
     * @return value or {@code null} for none
     */
    public java.lang.Long getElapsedMillis() {
      return elapsedMillis;
    }

    /**
     * Google internal
     * @param elapsedMillis elapsedMillis or {@code null} for none
     */
    public BackendTimes setElapsedMillis(java.lang.Long elapsedMillis) {
      this.elapsedMillis = elapsedMillis;
      return this;
    }

    /**
     * Google internal
     * @return value or {@code null} for none
     */
    public java.lang.String getHostName() {
      return hostName;
    }

    /**
     * Google internal
     * @param hostName hostName or {@code null} for none
     */
    public BackendTimes setHostName(java.lang.String hostName) {
      this.hostName = hostName;
      return this;
    }

    /**
     * Google internal
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Google internal
     * @param name name or {@code null} for none
     */
    public BackendTimes setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * Google internal
     * @return value or {@code null} for none
     */
    public java.lang.Long getServerMillis() {
      return serverMillis;
    }

    /**
     * Google internal
     * @param serverMillis serverMillis or {@code null} for none
     */
    public BackendTimes setServerMillis(java.lang.Long serverMillis) {
      this.serverMillis = serverMillis;
      return this;
    }

    @Override
    public BackendTimes set(String fieldName, Object value) {
      return (BackendTimes) super.set(fieldName, value);
    }

    @Override
    public BackendTimes clone() {
      return (BackendTimes) super.clone();
    }

  }

}
