/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 19:15:42 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.shopping.model;

/**
 * Model definition for ShoppingModelExtrasJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelExtrasJsonV1 extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<FacetRules> facetRules;

  static {
    // hack to force ProGuard to consider FacetRules used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(FacetRules.class);
  }

  /**
   * Names of boost (ranking) rules applicable to this search.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<RankingRules> rankingRules;

  static {
    // hack to force ProGuard to consider RankingRules used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(RankingRules.class);
  }

  /**
   * @return value or {@code null} for none
   */
  public java.util.List<FacetRules> getFacetRules() {
    return facetRules;
  }

  /**
   * @param facetRules facetRules or {@code null} for none
   */
  public ShoppingModelExtrasJsonV1 setFacetRules(java.util.List<FacetRules> facetRules) {
    this.facetRules = facetRules;
    return this;
  }

  /**
   * Names of boost (ranking) rules applicable to this search.
   * @return value or {@code null} for none
   */
  public java.util.List<RankingRules> getRankingRules() {
    return rankingRules;
  }

  /**
   * Names of boost (ranking) rules applicable to this search.
   * @param rankingRules rankingRules or {@code null} for none
   */
  public ShoppingModelExtrasJsonV1 setRankingRules(java.util.List<RankingRules> rankingRules) {
    this.rankingRules = rankingRules;
    return this;
  }

  @Override
  public ShoppingModelExtrasJsonV1 set(String fieldName, Object value) {
    return (ShoppingModelExtrasJsonV1) super.set(fieldName, value);
  }

  @Override
  public ShoppingModelExtrasJsonV1 clone() {
    return (ShoppingModelExtrasJsonV1) super.clone();
  }

  /**
   * Model definition for ShoppingModelExtrasJsonV1FacetRules.
   */
  public static final class FacetRules extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * @param name name or {@code null} for none
     */
    public FacetRules setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    @Override
    public FacetRules set(String fieldName, Object value) {
      return (FacetRules) super.set(fieldName, value);
    }

    @Override
    public FacetRules clone() {
      return (FacetRules) super.clone();
    }

  }

  /**
   * Model definition for ShoppingModelExtrasJsonV1RankingRules.
   */
  public static final class RankingRules extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * @param name name or {@code null} for none
     */
    public RankingRules setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    @Override
    public RankingRules set(String fieldName, Object value) {
      return (RankingRules) super.set(fieldName, value);
    }

    @Override
    public RankingRules clone() {
      return (RankingRules) super.clone();
    }

  }

}
