/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 19:15:42 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.shopping.model;

/**
 * Model definition for ShoppingModelRecommendationsJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelRecommendationsJsonV1 extends com.google.api.client.json.GenericJson {

  /**
   * List of recommendations.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<RecommendationList> recommendationList;

  static {
    // hack to force ProGuard to consider RecommendationList used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(RecommendationList.class);
  }

  /**
   * Type of recommendation list (for offer-based recommendations, one of: all, purchaseToPurchase,
   * visitToVisit, visitToPurchase, relatedItems; for category-based recommendations, one of: all,
   * categoryMostVisited, categoryBestSeller).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * List of recommendations.
   * @return value or {@code null} for none
   */
  public java.util.List<RecommendationList> getRecommendationList() {
    return recommendationList;
  }

  /**
   * List of recommendations.
   * @param recommendationList recommendationList or {@code null} for none
   */
  public ShoppingModelRecommendationsJsonV1 setRecommendationList(java.util.List<RecommendationList> recommendationList) {
    this.recommendationList = recommendationList;
    return this;
  }

  /**
   * Type of recommendation list (for offer-based recommendations, one of: all, purchaseToPurchase,
   * visitToVisit, visitToPurchase, relatedItems; for category-based recommendations, one of: all,
   * categoryMostVisited, categoryBestSeller).
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * Type of recommendation list (for offer-based recommendations, one of: all, purchaseToPurchase,
   * visitToVisit, visitToPurchase, relatedItems; for category-based recommendations, one of: all,
   * categoryMostVisited, categoryBestSeller).
   * @param type type or {@code null} for none
   */
  public ShoppingModelRecommendationsJsonV1 setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public ShoppingModelRecommendationsJsonV1 set(String fieldName, Object value) {
    return (ShoppingModelRecommendationsJsonV1) super.set(fieldName, value);
  }

  @Override
  public ShoppingModelRecommendationsJsonV1 clone() {
    return (ShoppingModelRecommendationsJsonV1) super.clone();
  }

  /**
   * Model definition for ShoppingModelRecommendationsJsonV1RecommendationList.
   */
  public static final class RecommendationList extends com.google.api.client.json.GenericJson {

    /**
     * Recommended product.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private ShoppingModelProductJsonV1 product;

    /**
     * Recommended product.
     * @return value or {@code null} for none
     */
    public ShoppingModelProductJsonV1 getProduct() {
      return product;
    }

    /**
     * Recommended product.
     * @param product product or {@code null} for none
     */
    public RecommendationList setProduct(ShoppingModelProductJsonV1 product) {
      this.product = product;
      return this;
    }

    @Override
    public RecommendationList set(String fieldName, Object value) {
      return (RecommendationList) super.set(fieldName, value);
    }

    @Override
    public RecommendationList clone() {
      return (RecommendationList) super.clone();
    }

  }

}
